import tkinter as tk
from tkinter import ttk
from Graph import Graph


class TKObject:

    def __init__(self, parent, file):
        self.parent = parent
        self.df = file
        self.graph = Graph(parent, file)

    def add_text(self) -> None:
        self.head = tk.Label(self.parent, text="NASA Astronaut Comparison and Statistics",
                             font=("Futura", 40), bg="#0b3d91")
        self.property = tk.Label(self.parent, text="Overall Astronaut Properties (with astronauts as y-axis)",
                                 font=("Futura", 15), bg="#0b3d91")
        self.line = tk.Label(self.parent, text='━' * 70, bg="#0b3d91")
        self.compare = tk.Label(self.parent, text="Comparison Section", font=("Futura", 20), bg="#0b3d91")
        self.name = tk.Label(self.parent, text="Name: ", font=("Futura", 12), bg="#0b3d91")
        self.group = tk.Label(self.parent, text="Group: ", font=("Futura", 12), bg="#0b3d91")
        self.born = tk.Label(self.parent, text="Born: ", font=("Futura", 12), bg="#0b3d91")
        self.gender = tk.Label(self.parent, text="Gender: ", font=("Futura", 12), bg="#0b3d91")
        self.credit = tk.Label(self.parent, text="Made by Vorakorn Leechavanan", font=("Futura", 12), bg="#0b3d91")
        self.name_2 = tk.Label(self.parent, text="Name: ", font=("Futura", 12), bg="#0b3d91")
        self.group_2 = tk.Label(self.parent, text="Group: ", font=("Futura", 12), bg="#0b3d91")
        self.born_2 = tk.Label(self.parent, text="Born: ", font=("Futura", 12), bg="#0b3d91")
        self.gender_2 = tk.Label(self.parent, text="Gender: ", font=("Futura", 12), bg="#0b3d91")
        self.spacewalk_hours = tk.Label(self.parent, text="Spacewalk Hours", font=("Futura", 10), bg="#0b3d91")
        self.spacewalk = tk.Label(self.parent, text="Spacewalk", font=("Futura", 10), bg="#0b3d91")
        self.spaceflight_hours = tk.Label(self.parent, text="Spaceflight Hours\n(millihours)",
                                          font=("Futura", 10), bg="#0b3d91")
        self.spaceflight = tk.Label(self.parent, text="Spaceflight", font=("Futura", 10), bg="#0b3d91")

        self.u_name = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_group = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_born = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_gender = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_name_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_group_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_born_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_gender_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_spacewalk_hours = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_spacewalk = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_spaceflight_hours = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_spaceflight = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_spacewalk_hours_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_spacewalk_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_spaceflight_hours_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_spaceflight_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")

        self.stat = tk.Label(self.parent, text="SwH mean:\nSwH SD:\nSwH min:\nSwH max:",
                             font=("Futura", 10), bg="#0b3d91")
        self.stat_2 = tk.Label(self.parent, text="Sw mean:\nSw SD:\nSw min:\nSw max:",
                               font=("Futura", 10), bg="#0b3d91")
        self.stat_3 = tk.Label(self.parent, text="SfmH mean:\nSfmH SD:\nSfmH min:\nSfmH max:",
                               font=("Futura", 10), bg="#0b3d91")
        self.stat_4 = tk.Label(self.parent, text="Sf mean:\nSf SD:\nSf min:\nSf max:",
                               font=("Futura", 10), bg="#0b3d91")

        self.u_stat = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_stat_2 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_stat_3 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")
        self.u_stat_4 = tk.Label(self.parent, font=("Futura", 10), bg="#0b3d91")

        self.des_1 = tk.Label(self.parent, text="This is the heatmap to show \nthe correlation of properties pair",
                              font=("Futura", 10), bg="#0b3d91")
        self.des_2 = tk.Label(self.parent, text="The proportion between \nmale and female astronauts",
                              font=("Futura", 10), bg="#0b3d91")

        self.head.place(relx=.11, rely=.085)
        self.property.place(relx=.325, rely=.18)
        self.line.place(relx=.045, rely=.51)
        self.compare.place(relx=.09, rely=.55)
        self.name.place(relx=.075, rely=.65)
        self.group.place(relx=.075, rely=.7)
        self.born.place(relx=.075, rely=.75)
        self.gender.place(relx=.075, rely=.8)
        self.credit.place(relx=.415, rely=.96)
        self.name_2.place(relx=.796, rely=.65)
        self.group_2.place(relx=.796, rely=.7)
        self.born_2.place(relx=.796, rely=.75)
        self.gender_2.place(relx=.796, rely=.8)
        self.spacewalk_hours.place(relx=.469, rely=.65)
        self.spacewalk.place(relx=.482, rely=.717)
        self.spaceflight_hours.place(relx=.469, rely=.788)
        self.spaceflight.place(relx=.485, rely=.852)

        self.u_name.place(relx=.117, rely=.652)
        self.u_group.place(relx=.12, rely=.702)
        self.u_born.place(relx=.112, rely=.752)
        self.u_gender.place(relx=.125, rely=.802)
        self.u_name_2.place(relx=.842, rely=.652)
        self.u_group_2.place(relx=.847, rely=.702)
        self.u_born_2.place(relx=.837, rely=.752)
        self.u_gender_2.place(relx=.85, rely=.802)
        self.u_spacewalk_hours.place(relx=.275, rely=.645)
        self.u_spacewalk_hours_2.place(relx=.735, rely=.645)
        self.u_spacewalk.place(relx=.275, rely=.715)
        self.u_spacewalk_2.place(relx=.735, rely=.715)
        self.u_spaceflight_hours.place(relx=.265, rely=.785)
        self.u_spaceflight_hours_2.place(relx=.73, rely=.785)
        self.u_spaceflight.place(relx=.275, rely=.855)
        self.u_spaceflight_2.place(relx=.735, rely=.855)

        self.stat.place(relx=.075, rely=.9)
        self.stat_2.place(relx=.2, rely=.9)
        self.stat_3.place(relx=.725, rely=.9)
        self.stat_4.place(relx=.865, rely=.9)

        self.u_stat.place(relx=.15, rely=.9)
        self.u_stat_2.place(relx=.275, rely=.9)
        self.u_stat_3.place(relx=.8, rely=.9)
        self.u_stat_4.place(relx=.94, rely=.9)

        self.des_1.place(relx=.1375, rely=.465)
        self.des_2.place(relx=.725, rely=.465)

    def create_dropdown(self) -> None:
        self.options = list(self.df['name'])
        self.options_2 = [f"Group {n + 1}" for n in range(self.df['group'].nunique())]
        self.options = [self.options[0]] + self.options
        self.options_2 = [self.options_2[0]] + self.options_2

        self.value = tk.StringVar()
        self.drop = ttk.OptionMenu(self.parent, self.value, *self.options, command=self.update_text)
        self.drop.configure(width=12)
        self.drop.place(relx=.075, rely=.852)

        self.value_2 = tk.StringVar()
        self.drop_2 = ttk.OptionMenu(self.parent, self.value_2, *self.options, command=self.update_text)
        self.drop_2.configure(width=12)
        self.drop_2.place(relx=.7935, rely=.852)

        self.value_3 = tk.StringVar()
        self.drop_3 = ttk.OptionMenu(self.parent, self.value_3,
                                     *['group (hist)', 'group (hist)', 'spaceflights (hist)',
                                       'spaceflight_hours (hist)', 'spacewalks (hist)',
                                       'spacewalk_hours (hist)', 'spaceflights (boxplot)',
                                       'spaceflight_hours (boxplot)', 'spacewalks (boxplot)',
                                       'spacewalk_hours (boxplot)'
                                       ], command=self.update_hist)
        self.drop_3.configure(width=12)
        self.drop_3.place(relx=.435, rely=.47)

        self.value_4 = tk.StringVar()
        self.drop_4 = ttk.OptionMenu(self.parent, self.value_4, *self.options_2, command=self.update_text)
        self.drop_4.configure(width=4)
        self.drop_4.place(relx=.46875, rely=.91)

    def update_text(self, _arg=None) -> None:
        row = self.df.loc[self.df['name'] == self.value.get()]
        self.u_name.configure(text=self.value.get())
        self.u_group.configure(text=f"{row['group'].iloc[0]}")
        self.u_born.configure(text=f"{row['dob'].iloc[0]}")
        self.u_gender.configure(text=f"{row['gender'].iloc[0]}")
        self.u_spacewalk_hours.configure(text=f"{row['spacewalk_hours'].iloc[0]}")
        self.u_spacewalk.configure(text=f"{row['spacewalks'].iloc[0]}")
        self.u_spaceflight_hours.configure(text=f"{row['spaceflight_hours'].iloc[0]/1000}")
        self.u_spaceflight.configure(text=f"{row['spaceflights'].iloc[0]}")

        row_2 = self.df.loc[self.df['name'] == self.value_2.get()]
        self.u_name_2.configure(text=self.value_2.get())
        self.u_group_2.configure(text=f"{row_2['group'].iloc[0]}")
        self.u_born_2.configure(text=f"{row_2['dob'].iloc[0]}")
        self.u_gender_2.configure(text=f"{row_2['gender'].iloc[0]}")
        self.u_spacewalk_hours_2.configure(text=f"{row_2['spacewalk_hours'].iloc[0]}")
        self.u_spacewalk_2.configure(text=f"{row_2['spacewalks'].iloc[0]}")
        self.u_spaceflight_hours_2.configure(text=f"{row_2['spaceflight_hours'].iloc[0] / 1000}")
        self.u_spaceflight_2.configure(text=f"{row_2['spaceflights'].iloc[0]}")

        row_3 = self.df.loc[self.df['group'] == int(self.value_4.get()[6:])]
        self.u_stat.configure(text=f"{row_3['spacewalk_hours'].mean():.2f}\n"
                                   f"{row_3['spacewalk_hours'].std():.2f}\n"
                                   f"{row_3['spacewalk_hours'].min()}\n"
                                   f"{row_3['spacewalk_hours'].max()}"
                              )
        self.u_stat_2.configure(text=f"{row_3['spacewalks'].mean():.2f}\n"
                                   f"{row_3['spacewalks'].std():.2f}\n"
                                   f"{row_3['spacewalks'].min()}\n"
                                   f"{row_3['spacewalks'].max()}"
                                )
        self.u_stat_3.configure(text=f"{row_3['spaceflight_hours'].mean()/1000:.2f}\n"
                                     f"{row_3['spaceflight_hours'].std()/1000:.2f}\n"
                                     f"{row_3['spaceflight_hours'].min()/1000}\n"
                                     f"{row_3['spaceflight_hours'].max()/1000}"
                                )
        self.u_stat_4.configure(text=f"{row_3['spaceflights'].mean():.2f}\n"
                                     f"{row_3['spaceflights'].std():.2f}\n"
                                     f"{row_3['spaceflights'].min()}\n"
                                     f"{row_3['spaceflights'].max()}"
                                )
        self.update_bar()

    def update_bar(self) -> None:
        self.graph.bar_chart(self.value.get(), self.value_2.get())

    def update_hist(self, _arg=None) -> None:
        if "hist" in self.value_3.get():
            self.graph.histogram(self.value_3.get()[:-7])
        else:
            self.update_box()

    def update_box(self) -> None:
        self.graph.boxplot(self.value_3.get()[:-10])


